apiVersion: apps/v1
kind: Deployment
metadata:
  name: spring-boot
  labels:
    app: spring-boot
spec:
  replicas: 1
  selector:
    matchLabels:
      app: spring-boot
  template:
    metadata:
      labels:
        app: spring-boot
    spec:
      initContainers:
      - name: wait-for-db
        image: mysql
        command: ['sh', '/scripts/check-db.sh']
        volumeMounts:
        - name: check-db-script
          mountPath: /scripts
      containers:
      - name: spring-boot
        image: super23/my-java-app:240609-48051cf8
        ports:
        - containerPort: 8090
        env:
        - name: SPRING_DATASOURCE_USERNAME
          valueFrom:
            secretKeyRef:
              name: mysqldb-secret
              key: mysql-root-username
        - name: SPRING_DATASOURCE_PASSWORD
          valueFrom: 
            secretKeyRef:
              name: mysqldb-secret
              key: mysql-root-password
        - name: SPRING_DATASOURCE_URL
          valueFrom: 
            configMapKeyRef:
              name: mysqldb-configmap
              key: database_url
      volumes:
      - name: check-db-script
        configMap:
          name: check-db-configmap
---
apiVersion: v1
kind: Service
metadata:
  name: spring-boot-service
spec:
  selector:
    app: spring-boot 
  ports:
    - protocol: TCP
      port: 8090
      targetPort: 8090
